'use strict';

var _system = require('system');

var _system2 = _interopRequireDefault(_system);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Server = require(phantom.libraryPath + '/server').default;
var Logger = require(phantom.libraryPath + '/utils/logger').default;
var PhantomError = require(phantom.libraryPath + '/utils/error').default;

var logger = new Logger('Main');
var server = new Server();

phantom.onError = function onError(msg, trace) {
  var error = new PhantomError(msg, trace);

  phantom.exit(1);
  logger.error(error);
};

try {
  var buffer = _system2.default.stdin.readLine();
  var json = JSON.parse(buffer.toString() || '');

  switch (json.command) {
    case 'startServer':
      server.start(json.options);
      break;
    default:
      throw new Error('could not interpret command');
  }
} catch (error) {
  logger.error(error);
  phantom.exit(1);
}