'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _webserver = require('webserver');

var _webserver2 = _interopRequireDefault(_webserver);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

// n.b. Phantom's require uses a different resolver, so we libraryPath
var Page = require(phantom.libraryPath + '/page').default;
var Logger = require(phantom.libraryPath + '/utils/logger').default;

var logger = new Logger('Server');

var Server = function () {
  function Server() {
    var pageOptions = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, Server);

    this.server = _webserver2.default.create();
    this.page = new Page(pageOptions);
  }

  /* eslint-disable no-param-reassign */


  _createClass(Server, [{
    key: 'start',
    value: function start() {
      var _this = this;

      var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
          _ref$port = _ref.port,
          port = _ref$port === undefined ? 8180 : _ref$port,
          url = _ref.url,
          html = _ref.html,
          dpi = _ref.dpi,
          viewportSize = _ref.viewportSize,
          zoomFactor = _ref.zoomFactor;

      if (dpi !== undefined) {
        this.page.dpi = dpi;
      }

      if (viewportSize !== undefined) {
        this.page.viewportSize = viewportSize;
      }

      if (zoomFactor !== undefined) {
        this.page.zoomFactor = zoomFactor;
      }

      this.page.load({ url: url, html: html });
      this.server.listen(port, function (request, response) {
        try {
          if (request.url === '/render' && request.method === 'POST') {
            var options = JSON.parse(request.post || '');
            var filename = _this.page.render(options);

            response.statusCode = 303;
            response.write(filename);
          } else {
            response.statusCode = 404;
            response.write('');
          }
        } catch (error) {
          response.statusCode = 500;
          response.write(error.message || error || JSON.stringify(error));

          logger.error(JSON.stringify(response));
        }

        response.close();
      });
    }
    /* eslint-enable no-param-reassign */

  }, {
    key: 'stop',
    value: function stop() {
      this.server.close();
      phantom.exit(null);
    }
  }]);

  return Server;
}();

exports.default = Server;