'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.RenderVendor = exports.Renderer = undefined;

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _renderer = require('./renderer');

var _renderer2 = _interopRequireDefault(_renderer);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var BASE_PORT = 8180;

var _renderers = [];

var RenderVendor = {
  _nextPort: BASE_PORT,

  create: function create() {
    var rendererOptions = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    var renderer = void 0;
    var options = _lodash2.default.defaults(rendererOptions, {
      port: RenderVendor._nextPort
    });

    if (options.port === RenderVendor._nextPort) {
      RenderVendor._nextPort += 1;
    }

    renderer = new _renderer2.default(options);
    _renderers.push(renderer);

    return renderer;
  },
  destroy: function destroy(renderer) {
    _renderers.splice(_renderers.indexOf(renderer), 1);
    renderer.shutdown();
  },
  renderers: function renderers() {
    return _renderers;
  },
  shutdown: function shutdown() {
    _renderers.forEach(RenderVendor.destroy);
    RenderVendor._nextPort = BASE_PORT;
  }
};

exports.Renderer = _renderer2.default;
exports.RenderVendor = RenderVendor;
exports.default = RenderVendor;