'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _assert = require('assert');

var _assert2 = _interopRequireDefault(_assert);

var _request = require('request');

var _request2 = _interopRequireDefault(_request);

var _rsvp = require('rsvp');

var _rsvp2 = _interopRequireDefault(_rsvp);

var _phantom = require('./phantom');

var _phantom2 = _interopRequireDefault(_phantom);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var denodeify = _rsvp2.default.denodeify;

var Renderer = function () {
  function Renderer() {
    var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
        _ref$phantomOptions = _ref.phantomOptions,
        phantomOptions = _ref$phantomOptions === undefined ? {} : _ref$phantomOptions,
        port = _ref.port,
        url = _ref.url,
        html = _ref.html;

    _classCallCheck(this, Renderer);

    _assert2.default.ok(port, 'missing `port`');
    _assert2.default.ok(url || html, 'missing either `url` or `html`');

    this.phantom = new _phantom2.default(phantomOptions);
    this.port = this.phantom.startServer({ port: port, url: url, html: html });
  }

  _createClass(Renderer, [{
    key: 'render',
    value: function render() {
      var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

      var renderJob = this._renderJob || this._render(options);
      return renderJob;
    }
  }, {
    key: '_render',
    value: function _render(renderOptions) {
      var _this = this;

      this._renderJob = this._exec({
        command: 'render',
        options: {
          body: renderOptions
        }
      }).then(function (response) {
        if (response.statusCode !== 303) {
          var res = JSON.stringify(response);
          throw new Error('Renderer - Unexpected Response: ' + res);
        }

        return response.body;
      }).catch(function (err) {
        if (err instanceof Error) {
          throw err;
        } else {
          throw new Error('Renderer - RenderError: ' + err);
        }
      }).finally(function () {
        _this._renderJob = null;
      });

      return this._renderJob;
    }
  }, {
    key: 'shutdown',
    value: function shutdown() {
      this.phantom.shutdown();
    }
  }, {
    key: '_exec',
    value: function _exec(_ref2) {
      var command = _ref2.command,
          _ref2$options = _ref2.options,
          options = _ref2$options === undefined ? {} : _ref2$options;

      _assert2.default.ok('command', 'missing command');

      var post = denodeify(_request2.default.post);
      var url = 'http://localhost:' + this.port + '/' + command;

      return post(url, _lodash2.default.defaults(options, {
        json: true
      }));
    }
  }]);

  return Renderer;
}();

exports.default = Renderer;